-- ready to load!

-- light = 500
pins = {
    open = 7,
    close = 6,
    ledOpen = 2 
}

data = {
    false, -- isOpen
    false, -- isWater 
    true,  -- work 
	"valve",
	"watering",
	"working"
}

for _, pin in pairs(pins) do
    gpio.mode(pin, gpio.OUTPUT)
    gpio.write(pin, gpio.HIGH)
end
gpio.write(pins.ledOpen, gpio.LOW)

Broker="ВАШ_САЙТ"
port=ВАШ_ПОРТ
myClient="garden"
pass="pass"
publish = false
count = 1

m = mqtt.Client(myClient, 180, myClient, pass)
m:lwt("/lwt", myClient, 0, 0)

function connecting() -- tmr 3
    publish = false
    local function getConnect()    
       if wifi.sta.status() == 5 and wifi.sta.getip() ~= nil then 
            m:connect(Broker, port, 0, 0,
                function(conn)
                    publish = true
                    tmr.stop(3)
                    tmr.unregister(3)
                    m:subscribe(myClient.."/#",0, function(conn)
                    end)
            end)    
        end
    end
    getConnect() 
    tmr.alarm(3, 90000, 1, function()
        getConnect()
    end)
end

m:on("offline", function(con)
    publish = false
    connecting()
end)

function pM()
	local count = 1
	local tt, mm
	local pubb = function(mess, topic)
		if publish == true then 
			topic = topic or "valve"
			m:publish(myClient.."/"..topic.."/state",mess,0,0)
			mm = data[count]
			if mm == false then mm = "OFF" else mm = "ON" end
			tt = data[count + 3]
			count = count + 1
			if count == 4 then count = 1 end
			m:publish(myClient.."/"..tt.."/state",mm,0,0)
		end
	end
	return pubb
end
 
pubMess = pM()

m:on("message", function(conn, topic, dt)
	if (string.find(topic, "state")) == nil then 
        local top = string.gsub(topic, myClient.."/","") 
        print(top..":"..dt) 
        if top == "vl" then
            if dt == "ON" then
                turnOn(pins.open)
            else
                turnOn(pins.close)
            end
        end
        if top == "gr" then
            if dt == "ON" then
                data[3] = true
				data[2] = false
                print('work = true')
                pubMess("ON", "working")
            else
                data[3] = false
                print('work = false')
                pubMess("OFF","working")
				tmr.stop(5)
				turnOn(pins.close)
            end
        end
    end
    collectgarbage() 
end)

function debounce (func)
    local last = 0
    local delay = 60000

    return function (...)
        local now = tmr.now()
        if now - last < delay then 
          return 
        end

        last = now
        return func(...)
    end
end

function onChange ()
    if  gpio.read(1) == 0  then
            if data[1] == true then
                turnOn(pins.close)
            else
                turnOn(pins.open)
            end
    end
end

function turnOn(pin) -- tmr 1,2 
    tmr.stop(1)
    gpio.write(pins.open, gpio.HIGH)
    gpio.write(pins.close, gpio.HIGH)
    
    gpio.write(pin, gpio.LOW)
    print('Power ON pin '..pin)
    
    tmr.alarm(1, 30000, tmr.ALARM_SINGLE, function() 
        gpio.write(pin, gpio.HIGH)
        print("Power OFF from 30 sec. pin "..pin)
    end)
    
    if pin == pins.open then
        data[1] = true -- isOpen
        pubMess("ON")
        gpio.write(pins.ledOpen, gpio.HIGH)
        print("Valve is open")
        tmr.alarm(2, 2700000, tmr.ALARM_SINGLE, function()
            print("Time to Close by Time")
            turnOn(pins.close)
        end)
    else -- pin close
        pubMess("OFF")
        tmr.stop(2)
        gpio.write(pins.ledOpen, gpio.LOW)
        print("Valve is closed")
        data[1] = false -- isOpen
    end
end

function delayStart()
    local counter = 0
    tmr.alarm(5, 3600000, tmr.ALARM_AUTO, function() 
        counter = counter + 1
        if counter > 3 then
			counter = 0
            tmr.stop(5)
            tmr.unregister(5)
			if data[3] then turnOn(pins.open) end
        end
    end)
end


tmr.alarm(4, 10000, tmr.ALARM_AUTO, function() -- check ight
    local light = adc.read(0)
    print("Light: ", light)
    pubMess(light, "light")
		
    if light > 1020 and data[2] == false and data[3] == true then
        pubMess("OFF", "day")
        data[2] = true
		print("delayStart")
        delayStart()
    end
    if light < 350 and data[2] == true then
        data[2] = false
        print('Day now!')
        pubMess("ON", "day")
    end 
end)

gpio.mode(1, gpio.INT)
gpio.trig(1, 'down', debounce(onChange))

connecting()
